From 6d3914087f8e3cca47a1334569bc41affb503b5a Mon Sep 17 00:00:00 2001
From: Ludwig Krispenz <lkrispen@redhat.com>
Date: Tue, 27 Nov 2018 14:11:13 +0100
Subject: [PATCH 1/2] BACKEND REDESIGN -Phase 1 - make config generic

---
 Makefile.am                                   |    5 -
 ldap/servers/slapd/back-ldbm/archive.c        |   25 +-
 ldap/servers/slapd/back-ldbm/back-ldbm.h      |    4 +
 ldap/servers/slapd/back-ldbm/cleanup.c        |   51 +-
 ldap/servers/slapd/back-ldbm/dblayer.c        | 7489 ++---------------
 ldap/servers/slapd/back-ldbm/dblayer.h        |  128 +-
 ldap/servers/slapd/back-ldbm/dbsize.c         |    9 +-
 ldap/servers/slapd/back-ldbm/dbverify.c       |  211 +-
 ldap/servers/slapd/back-ldbm/dbversion.c      |  200 -
 ldap/servers/slapd/back-ldbm/idl.c            |   26 +-
 ldap/servers/slapd/back-ldbm/import-merge.c   |  705 --
 ldap/servers/slapd/back-ldbm/import-threads.c | 4011 ---------
 ldap/servers/slapd/back-ldbm/import.c         | 1653 +---
 ldap/servers/slapd/back-ldbm/import.h         |    4 +-
 ldap/servers/slapd/back-ldbm/init.c           |   12 +-
 ldap/servers/slapd/back-ldbm/ldbm_config.c    | 1087 +--
 ldap/servers/slapd/back-ldbm/ldbm_config.h    |    1 +
 .../slapd/back-ldbm/ldbm_index_config.c       |    2 +-
 .../slapd/back-ldbm/ldbm_instance_config.c    |  228 -
 ldap/servers/slapd/back-ldbm/ldif2ldbm.c      | 1658 +---
 ldap/servers/slapd/back-ldbm/monitor.c        |  312 -
 .../servers/slapd/back-ldbm/proto-back-ldbm.h |   20 +-
 ldap/servers/slapd/back-ldbm/rmdb.c           |    5 +-
 ldap/servers/slapd/back-ldbm/start.c          |   16 +-
 ldap/servers/slapd/back-ldbm/upgrade.c        |  412 -
 ldap/servers/slapd/back-ldbm/vlv_srch.c       |    4 +-
 ldap/servers/slapd/slapi-plugin.h             |    6 +-
 27 files changed, 1103 insertions(+), 17181 deletions(-)
 delete mode 100644 ldap/servers/slapd/back-ldbm/dbversion.c
 delete mode 100644 ldap/servers/slapd/back-ldbm/import-merge.c
 delete mode 100644 ldap/servers/slapd/back-ldbm/import-threads.c
 delete mode 100644 ldap/servers/slapd/back-ldbm/monitor.c
 delete mode 100644 ldap/servers/slapd/back-ldbm/upgrade.c

diff --git a/Makefile.am b/Makefile.am
index 1fa4b71e9..6b9533fe7 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -1419,7 +1419,6 @@ libback_ldbm_la_SOURCES = ldap/servers/slapd/back-ldbm/ancestorid.c \
 	ldap/servers/slapd/back-ldbm/dbhelp.c \
 	ldap/servers/slapd/back-ldbm/dblayer.c \
 	ldap/servers/slapd/back-ldbm/dbsize.c \
-	ldap/servers/slapd/back-ldbm/dbversion.c \
 	ldap/servers/slapd/back-ldbm/dn2entry.c \
 	ldap/servers/slapd/back-ldbm/entrystore.c \
 	ldap/servers/slapd/back-ldbm/filterindex.c \
@@ -1432,8 +1431,6 @@ libback_ldbm_la_SOURCES = ldap/servers/slapd/back-ldbm/ancestorid.c \
 	ldap/servers/slapd/back-ldbm/idl_set.c \
 	ldap/servers/slapd/back-ldbm/idl_common.c \
 	ldap/servers/slapd/back-ldbm/import.c \
-	ldap/servers/slapd/back-ldbm/import-merge.c \
-	ldap/servers/slapd/back-ldbm/import-threads.c \
 	ldap/servers/slapd/back-ldbm/index.c \
 	ldap/servers/slapd/back-ldbm/init.c \
 	ldap/servers/slapd/back-ldbm/instance.c \
@@ -1458,7 +1455,6 @@ libback_ldbm_la_SOURCES = ldap/servers/slapd/back-ldbm/ancestorid.c \
 	ldap/servers/slapd/back-ldbm/dbverify.c \
 	ldap/servers/slapd/back-ldbm/matchrule.c \
 	ldap/servers/slapd/back-ldbm/misc.c \
-	ldap/servers/slapd/back-ldbm/monitor.c \
 	ldap/servers/slapd/back-ldbm/nextid.c \
 	ldap/servers/slapd/back-ldbm/parents.c \
 	ldap/servers/slapd/back-ldbm/perfctrs.c \
@@ -1467,7 +1463,6 @@ libback_ldbm_la_SOURCES = ldap/servers/slapd/back-ldbm/ancestorid.c \
 	ldap/servers/slapd/back-ldbm/sort.c \
 	ldap/servers/slapd/back-ldbm/start.c \
 	ldap/servers/slapd/back-ldbm/uniqueid2entry.c \
-	ldap/servers/slapd/back-ldbm/upgrade.c \
 	ldap/servers/slapd/back-ldbm/vlv.c \
 	ldap/servers/slapd/back-ldbm/vlv_key.c \
 	ldap/servers/slapd/back-ldbm/vlv_srch.c
diff --git a/ldap/servers/slapd/back-ldbm/archive.c b/ldap/servers/slapd/back-ldbm/archive.c
index 1b06cf916..1e6ad68bd 100644
--- a/ldap/servers/slapd/back-ldbm/archive.c
+++ b/ldap/servers/slapd/back-ldbm/archive.c
@@ -28,9 +28,6 @@ ldbm_back_archive2ldbm(Slapi_PBlock *pb)
     Slapi_Task *task;
     int is_old_to_new = 0;
     ldbm_instance *inst = NULL;
-    char *dbversion = NULL;
-    char *dataversion = NULL;
-    int value = 0;
 
     slapi_pblock_get(pb, SLAPI_PLUGIN_PRIVATE, &li);
     slapi_pblock_get(pb, SLAPI_SEQ_VAL, &rawdirectory);
@@ -45,6 +42,7 @@ ldbm_back_archive2ldbm(Slapi_PBlock *pb)
     }
 
     directory = rel2abspath(rawdirectory);
+    /* skip check for version and idl upgrade
     return_value = dbversion_read(li, directory, &dbversion, &dataversion);
     if (return_value) {
         if (ENOENT == return_value) {
@@ -55,8 +53,8 @@ ldbm_back_archive2ldbm(Slapi_PBlock *pb)
         slapi_log_err(SLAPI_LOG_WARNING, "ldbm_back_archive2ldbm",
                       "Unable to read dbversion file in %s\n", directory);
     }
-
-    /* check the current idl format vs backup DB version */
+*/
+    /* check the current idl format vs backup DB version
     if (idl_get_idl_new()) {
         value = lookup_dbversion(dbversion, DBVERSION_TYPE);
         if (value & DBVERSION_OLD_IDL) {
@@ -65,11 +63,16 @@ ldbm_back_archive2ldbm(Slapi_PBlock *pb)
     }
     slapi_ch_free_string(&dbversion);
     slapi_ch_free_string(&dataversion);
+*/
 
     /* No ldbm be's exist until we process the config information. */
     if (run_from_cmdline) {
         mapping_tree_init();
-        ldbm_config_load_dse_info(li);
+
+        if (dblayer_setup(li)) {
+            slapi_log_err(SLAPI_LOG_CRIT, "ldbm_back_init", "dblayer_setup failed\n");
+            return -1;
+        }
 
         /* initialize a restore file to be able to detect a startup after restore */
         if (dblayer_restore_file_init(li)) {
@@ -286,8 +289,16 @@ ldbm_back_ldbm2archive(Slapi_PBlock *pb)
     /* start the database code up, do not attempt to perform recovery */
     if (run_from_cmdline) {
         /* No ldbm be's exist until we process the config information. */
+
+    /* copied here, need better solution */
+    /* initialize dblayer  */
+        if (dblayer_setup(li)) {
+            slapi_log_err(SLAPI_LOG_CRIT, "ldbm_back_init", "dblayer_setup failed\n");
+            goto out;
+        }
+
         mapping_tree_init();
-        ldbm_config_load_dse_info(li);
+
         if (0 != (return_value =
                       dblayer_start(li,
                                     DBLAYER_ARCHIVE_MODE | DBLAYER_NO_DBTHREADS_MODE))) {
diff --git a/ldap/servers/slapd/back-ldbm/back-ldbm.h b/ldap/servers/slapd/back-ldbm/back-ldbm.h
index 79115fe12..e783f0f38 100644
--- a/ldap/servers/slapd/back-ldbm/back-ldbm.h
+++ b/ldap/servers/slapd/back-ldbm/back-ldbm.h
@@ -570,6 +570,8 @@ struct ldbminfo
     int li_shutdown;                     /* flag to tell any BE threads to end */
     PRLock *li_shutdown_mutex;           /* protect shutdown flag */
     dblayer_private *li_dblayer_private; /* session ptr for databases */
+    void *li_dblayer_config;             /* pointer to specific backend implementation */
+    char *li_backend_implement;          /* low layer backend implementation */
     int li_noparentcheck;                /* check if parent exists on add */
 
     /* the next 3 fields are for the params that don't get changed until
@@ -867,4 +869,6 @@ typedef struct _back_search_result_set
 #define DBT_EQ(L, R) \
     ((L)->dsize == (R)->dsize && !memcmp((L)->dptr, (R)->dptr, (L)->dsize))
 
+config_info * get_config_info(config_info *config_array, char *attr_name);
+typedef int backend_implement_init_fn(struct ldbminfo *li, config_info *config_array);
 #endif /* _back_ldbm_h_ */
diff --git a/ldap/servers/slapd/back-ldbm/cleanup.c b/ldap/servers/slapd/back-ldbm/cleanup.c
index 1b9be09af..3ad57944c 100644
--- a/ldap/servers/slapd/back-ldbm/cleanup.c
+++ b/ldap/servers/slapd/back-ldbm/cleanup.c
@@ -14,61 +14,16 @@
 /* cleanup.c - cleans up ldbm backend */
 
 #include "back-ldbm.h"
+#include "dblayer.h"
 
 int
 ldbm_back_cleanup(Slapi_PBlock *pb)
 {
     struct ldbminfo *li;
-    Slapi_Backend *be;
 
     slapi_log_err(SLAPI_LOG_TRACE, "ldbm_back_cleanup", "ldbm backend cleaning up\n");
     slapi_pblock_get(pb, SLAPI_PLUGIN_PRIVATE, &li);
-    slapi_pblock_get(pb, SLAPI_BACKEND, &be);
+    dblayer_private *priv = (dblayer_private *)li->li_dblayer_private;
 
-    if (be->be_state != BE_STATE_STOPPED &&
-        be->be_state != BE_STATE_DELETED) {
-        slapi_log_err(SLAPI_LOG_TRACE,
-                      "ldbm_back_cleanup", "Warning - backend is in a wrong state - %d\n",
-                      be->be_state);
-        return 0;
-    }
-
-    PR_Lock(be->be_state_lock);
-
-    if (be->be_state != BE_STATE_STOPPED &&
-        be->be_state != BE_STATE_DELETED) {
-        slapi_log_err(SLAPI_LOG_TRACE,
-                      "ldbm_back_cleanup", "Warning - backend is in a wrong state - %d\n",
-                      be->be_state);
-        PR_Unlock(be->be_state_lock);
-        return 0;
-    }
-
-    /*
-     * We check if li is NULL. Because of an issue in how we create backends
-     * we share the li and plugin info between many unique backends. This causes
-     * be_cleanall to try to trigger this multiple times. But we don't need to!
-     * dblayer_terminate is sufficent to be called once for each instance of
-     * ldbminfo. This protects us from heap use after frees while still cleaning
-     * up. Ultimately, it's a flaw in how ldbm can have many backends, but for
-     * "one" plugin.
-     */
-    if (li != NULL) {
-
-        dblayer_terminate(li);
-
-        /* JCM I tried adding this to tidy up memory on shutdown. */
-        /* JCM But, the result was very messy. */
-        objset_delete(&(li->li_instance_set));
-
-        ldbm_config_destroy(li);
-
-        slapi_pblock_set(pb, SLAPI_PLUGIN_PRIVATE, NULL);
-    }
-
-    be->be_state = BE_STATE_CLEANED;
-
-    PR_Unlock(be->be_state_lock);
-
-    return 0;
+    return priv->dblayer_cleanup_fn(pb);
 }
diff --git a/ldap/servers/slapd/back-ldbm/dblayer.c b/ldap/servers/slapd/back-ldbm/dblayer.c
index eaa7c301d..cd5b43cb8 100644
--- a/ldap/servers/slapd/back-ldbm/dblayer.c
+++ b/ldap/servers/slapd/back-ldbm/dblayer.c
@@ -90,64 +90,9 @@
     (env)->log_archive((env), (listp), (flags))
 #define LOG_FLUSH(env, lsn) (env)->log_flush((env), (lsn))
 
-/* Use these macros to incr/decrement the thread count for the
-   database housekeeping threads.  This ensures that the
-   value is changed in a thread safe manner, and safely notifies
-   the main thread during cleanup. INCR_THREAD_COUNT should be
-   the first real statement in the thread function, before any
-   actual work is done, other than perhaps variable assignments.
-   DECR_THREAD_COUNT should be called as the next to last thing
-   in the thread function, just before the trace log message and
-   return.
-*/
-#define INCR_THREAD_COUNT(priv)       \
-    PR_Lock(priv->thread_count_lock); \
-    ++priv->dblayer_thread_count;     \
-    PR_Unlock(priv->thread_count_lock)
-
-#define DECR_THREAD_COUNT(priv)                  \
-    PR_Lock(priv->thread_count_lock);            \
-    if (--priv->dblayer_thread_count == 0) {     \
-        PR_NotifyCondVar(priv->thread_count_cv); \
-    }                                            \
-    PR_Unlock(priv->thread_count_lock)
-
 #define NEWDIR_MODE 0755
 #define DB_REGION_PREFIX "__db."
 
-static int perf_threadmain(void *param);
-static int checkpoint_threadmain(void *param);
-static int trickle_threadmain(void *param);
-static int deadlock_threadmain(void *param);
-static int commit_good_database(dblayer_private *priv);
-static int read_metadata(struct ldbminfo *li);
-static int count_dbfiles_in_dir(char *directory, int *count, int recurse);
-static int dblayer_override_libdb_functions(DB_ENV *pEnv, dblayer_private *priv);
-static int dblayer_force_checkpoint(struct ldbminfo *li);
-static int log_flush_threadmain(void *param);
-static int dblayer_delete_transaction_logs(const char *log_dir);
-static int dblayer_is_logfilename(const char *path);
-static int dblayer_start_log_flush_thread(dblayer_private *priv);
-static int dblayer_start_deadlock_thread(struct ldbminfo *li);
-static int dblayer_start_checkpoint_thread(struct ldbminfo *li);
-static int dblayer_start_trickle_thread(struct ldbminfo *li);
-static int dblayer_start_perf_thread(struct ldbminfo *li);
-static int dblayer_start_txn_test_thread(struct ldbminfo *li);
-static int trans_batch_count = 0;
-static int trans_batch_limit = 0;
-static int trans_batch_txn_min_sleep = 50; /* ms */
-static int trans_batch_txn_max_sleep = 50;
-static PRBool log_flush_thread = PR_FALSE;
-static int txn_in_progress_count = 0;
-static int *txn_log_flush_pending = NULL;
-static PRLock *sync_txn_log_flush = NULL;
-static PRCondVar *sync_txn_log_flush_done = NULL;
-static PRCondVar *sync_txn_log_do_flush = NULL;
-static int dblayer_db_remove_ex(dblayer_private_env *env, char const path[], char const dbName[], PRBool use_lock);
-static void dblayer_init_pvt_txn(void);
-static void dblayer_push_pvt_txn(back_txn *txn);
-static back_txn *dblayer_get_pvt_txn(void);
-static void dblayer_pop_pvt_txn(void);
 
 static int dblayer_post_restore = 0;
 
@@ -182,32 +127,6 @@ static int dblayer_post_restore = 0;
 
    see also DBTcmp
 */
-int
-dblayer_bt_compare(DB *db, const DBT *dbt1, const DBT *dbt2)
-{
-    struct berval bv1, bv2;
-    value_compare_fn_type syntax_cmp_fn = (value_compare_fn_type)db->app_private;
-
-    if ((dbt1->data && (dbt1->size > 1) && (*((char *)dbt1->data) == EQ_PREFIX)) &&
-        (dbt2->data && (dbt2->size > 1) && (*((char *)dbt2->data) == EQ_PREFIX))) {
-        bv1.bv_val = (char *)dbt1->data + 1; /* remove leading '=' */
-        bv1.bv_len = (ber_len_t)dbt1->size - 1;
-
-        bv2.bv_val = (char *)dbt2->data + 1; /* remove leading '=' */
-        bv2.bv_len = (ber_len_t)dbt2->size - 1;
-
-        return syntax_cmp_fn(&bv1, &bv2);
-    }
-
-    /* else compare two "raw" index keys */
-    bv1.bv_val = (char *)dbt1->data;
-    bv1.bv_len = (ber_len_t)dbt1->size;
-
-    bv2.bv_val = (char *)dbt2->data;
-    bv2.bv_len = (ber_len_t)dbt2->size;
-
-    return slapi_berval_cmp(&bv1, &bv2);
-}
 
 static int
 db_uses_feature(DB_ENV *db_env, u_int32_t flags)
@@ -218,13 +137,11 @@ db_uses_feature(DB_ENV *db_env, u_int32_t flags)
 
     return (flags & openflags);
 }
-
 int
 dblayer_db_uses_locking(DB_ENV *db_env)
 {
     return db_uses_feature(db_env, DB_INIT_LOCK);
 }
-
 int
 dblayer_db_uses_transactions(DB_ENV *db_env)
 {
@@ -255,124 +172,6 @@ dblayer_db_uses_logging(DB_ENV *db_env)
     2 and 3 assume that nsslapd-db-transaction-batch-val is greater 0 at startup
 */
 
-int
-dblayer_set_batch_transactions(void *arg __attribute__((unused)), void *value, char *errorbuf __attribute__((unused)), int phase, int apply)
-{
-    int val = (int)((uintptr_t)value);
-    int retval = LDAP_SUCCESS;
-
-    if (apply) {
-        if (phase == CONFIG_PHASE_STARTUP) {
-            trans_batch_limit = val;
-        } else {
-            if (val == 0) {
-                if (log_flush_thread) {
-                    PR_Lock(sync_txn_log_flush);
-                }
-                trans_batch_limit = FLUSH_REMOTEOFF;
-                if (log_flush_thread) {
-                    log_flush_thread = PR_FALSE;
-                    PR_Unlock(sync_txn_log_flush);
-                }
-            } else if (val > 0) {
-                if (trans_batch_limit == FLUSH_REMOTEOFF) {
-                    /* this requires a server restart to take effect */
-                    slapi_log_err(SLAPI_LOG_NOTICE, "dblayer_set_batch_transactions", "Enabling batch transactions "
-                                                                                      "requires a server restart.\n");
-                } else if (!log_flush_thread) {
-                    /* we are already disabled, log a reminder of that fact. */
-                    slapi_log_err(SLAPI_LOG_NOTICE, "dblayer_set_batch_transactions", "Batch transactions was "
-                                                                                      "previously disabled, this update requires a server restart.\n");
-                }
-                trans_batch_limit = val;
-            }
-        }
-    }
-    return retval;
-}
-
-int
-dblayer_set_batch_txn_min_sleep(void *arg __attribute__((unused)), void *value, char *errorbuf __attribute__((unused)), int phase, int apply)
-{
-    int val = (int)((uintptr_t)value);
-    int retval = LDAP_SUCCESS;
-
-    if (apply) {
-        if (phase == CONFIG_PHASE_STARTUP || phase == CONFIG_PHASE_INITIALIZATION) {
-            trans_batch_txn_min_sleep = val;
-        } else {
-            if (val == 0) {
-                if (log_flush_thread) {
-                    PR_Lock(sync_txn_log_flush);
-                }
-                trans_batch_txn_min_sleep = FLUSH_REMOTEOFF;
-                if (log_flush_thread) {
-                    log_flush_thread = PR_FALSE;
-                    PR_Unlock(sync_txn_log_flush);
-                }
-            } else if (val > 0) {
-                if (trans_batch_txn_min_sleep == FLUSH_REMOTEOFF || !log_flush_thread) {
-                    /* this really has no effect until batch transactions are enabled */
-                    slapi_log_err(SLAPI_LOG_WARNING, "dblayer_set_batch_txn_min_sleep", "Warning batch transactions "
-                                                                                        "is not enabled.\n");
-                }
-                trans_batch_txn_min_sleep = val;
-            }
-        }
-    }
-    return retval;
-}
-
-int
-dblayer_set_batch_txn_max_sleep(void *arg __attribute__((unused)), void *value, char *errorbuf __attribute__((unused)), int phase, int apply)
-{
-    int val = (int)((uintptr_t)value);
-    int retval = LDAP_SUCCESS;
-
-    if (apply) {
-        if (phase == CONFIG_PHASE_STARTUP || phase == CONFIG_PHASE_INITIALIZATION) {
-            trans_batch_txn_max_sleep = val;
-        } else {
-            if (val == 0) {
-                if (log_flush_thread) {
-                    PR_Lock(sync_txn_log_flush);
-                }
-                trans_batch_txn_max_sleep = FLUSH_REMOTEOFF;
-                if (log_flush_thread) {
-                    log_flush_thread = PR_FALSE;
-                    PR_Unlock(sync_txn_log_flush);
-                }
-            } else if (val > 0) {
-                if (trans_batch_txn_max_sleep == FLUSH_REMOTEOFF || !log_flush_thread) {
-                    /* this really has no effect until batch transactions are enabled */
-                    slapi_log_err(SLAPI_LOG_WARNING,
-                                  "dblayer_set_batch_txn_max_sleep", "Warning batch transactions "
-                                                                     "is not enabled.\n");
-                }
-                trans_batch_txn_max_sleep = val;
-            }
-        }
-    }
-    return retval;
-}
-
-void *
-dblayer_get_batch_transactions(void *arg __attribute__((unused)))
-{
-    return (void *)((uintptr_t)trans_batch_limit);
-}
-
-void *
-dblayer_get_batch_txn_min_sleep(void *arg __attribute__((unused)))
-{
-    return (void *)((uintptr_t)trans_batch_txn_min_sleep);
-}
-
-void *
-dblayer_get_batch_txn_max_sleep(void *arg __attribute__((unused)))
-{
-    return (void *)((uintptr_t)trans_batch_txn_max_sleep);
-}
 
 /*
     Threading: dblayer isolates upper layers from threading considerations
@@ -383,78 +182,11 @@ dblayer_get_batch_txn_max_sleep(void *arg __attribute__((unused)))
     deserve. However, such a calling pattern will not crash your application !
 */
 
-static int
-dblayer_txn_checkpoint(struct ldbminfo *li, struct dblayer_private_env *env, PRBool busy_skip, PRBool db_force)
-{
-    int ret = 0;
-    if (busy_skip && is_anyinstance_busy(li)) {
-        return ret;
-    }
-    ret = TXN_CHECKPOINT(env->dblayer_DB_ENV, db_force ? DB_FORCE : 0, 0, 0);
-    return ret;
-}
-
-static int
-_dblayer_check_version(dblayer_private *priv)
-{
-    int major, minor = 0;
-    char *string = 0;
-    int ret = 0;
-
-    string = db_version(&major, &minor, NULL);
-    if (major < DB_VERSION_MAJOR) {
-        ret = -1;
-    } else {
-        ret = 0;
-    }
-    /* DB3X: always POST 24 :) */
-    priv->dblayer_lib_version = DBLAYER_LIB_VERSION_POST_24;
-    slapi_log_err(SLAPI_LOG_TRACE, "_dblayer_check_version", "version check: %s (%d.%d)\n", string, major, minor);
-    return ret;
-}
-
-
-/*
- * return nsslapd-db-home-directory (dblayer_dbhome_directory), if exists.
- * Otherwise, return nsslapd-directory (dblayer_home_directory).
- *
- * if dblayer_dbhome_directory exists, set 1 to dbhome.
- */
-char *
-dblayer_get_home_dir(struct ldbminfo *li, int *dbhome)
-{
-    dblayer_private *priv = (dblayer_private *)li->li_dblayer_private;
-    char *home_dir = priv->dblayer_home_directory;
-    if (dbhome)
-        *dbhome = 0;
-
-    if (priv->dblayer_dbhome_directory && *(priv->dblayer_dbhome_directory)) {
-        if (dbhome)
-            *dbhome = 1;
-        home_dir = priv->dblayer_dbhome_directory;
-    }
-    if (NULL == home_dir) {
-        slapi_log_err(SLAPI_LOG_WARNING, "dblayer_get_home_dir", "Db home directory is not set. "
-                                                                 "Possibly %s (optionally %s) is missing in the config file.\n",
-                      CONFIG_DIRECTORY, CONFIG_DB_HOME_DIRECTORY);
-    }
-    return home_dir;
-}
 
 /* Helper function which deletes the persistent state of the database library
  * IMHO this should be in inside libdb, but keith won't have it.
  * Stop press---libdb now does delete these files on recovery, so we don't call this any more.
  */
-static void
-dblayer_reset_env(struct ldbminfo *li)
-{
-    /* Remove the memory regions */
-    dblayer_private *priv = (dblayer_private *)li->li_dblayer_private;
-    DB_ENV *pEnv = priv->dblayer_env->dblayer_DB_ENV;
-    char *home_dir = dblayer_get_home_dir(li, NULL);
-    if (home_dir && *home_dir)
-        pEnv->remove(pEnv, home_dir, DB_FORCE);
-}
 
 /* Callback function for libdb to spit error info into our log */
 void
@@ -485,128 +217,6 @@ dblayer_remember_disk_filled(struct ldbminfo *li)
  * will magically work on all platforms (Ha!)
  */
 
-#ifdef DB_USE_64LFS
-/* What is going on here ?
- * Well, some platforms now support an extended API for dealing with
- * files larger than 2G.  (This apparently comes from the LFS -- "Large
- * File Summit"... Summit, indeed.)  Anyway, we try to detect at runtime
- * whether this machine has the extended API, and use it if it's present.
- *
- */
-
-
-/* helper function for open64 */
-static int
-dblayer_open_large(const char *path, int oflag, mode_t mode)
-{
-    int err;
-
-    err = open64(path, oflag, mode);
-    /* weird but necessary: */
-    if (err >= 0)
-        errno = 0;
-    return err;
-}
-
-/* this is REALLY dumb.  but nspr 19980529(x) doesn't support 64-bit files
- * because of some weirdness we're doing at initialization (?), so we need
- * to export some function that can open huge files, so that exporting
- * can work right.  when we fix the nspr problem (or get a more recent
- * version of nspr that might magically work?), this should be blown away.
- * (call mode_t an int because NT can't handle that in prototypes.)
- * -robey, 28oct98
- */
-int
-dblayer_open_huge_file(const char *path, int oflag, int mode)
-{
-    return dblayer_open_large(path, oflag, (mode_t)mode);
-}
-
-/* Helper function for large seeks, db4.3 */
-static int
-dblayer_seek43_large(int fd, off64_t offset, int whence)
-{
-    off64_t ret = 0;
-
-    ret = lseek64(fd, offset, whence);
-
-    return (ret < 0) ? errno : 0;
-}
-
-/* helper function for large fstat -- this depends on 'struct stat64' having
- * the following members:
- *    off64_t        st_size;
- *      long        st_blksize;
- */
-static int
-dblayer_ioinfo_large(const char *path __attribute__((unused)), int fd, u_int32_t *mbytesp, u_int32_t *bytesp, u_int32_t *iosizep)
-{
-    struct stat64 sb;
-
-    if (fstat64(fd, &sb) < 0)
-        return (errno);
-
-    /* Return the size of the file. */
-    if (mbytesp)
-        *mbytesp = (u_int32_t)(sb.st_size / (off64_t)MEGABYTE);
-    if (bytesp)
-        *bytesp = (u_int32_t)(sb.st_size % (off64_t)MEGABYTE);
-
-    if (iosizep)
-        *iosizep = (u_int32_t)(sb.st_blksize);
-    return 0;
-}
-/* Helper function to tell if a file exists */
-/* On Solaris, if you use stat() on a file >4Gbytes, it fails with EOVERFLOW,
-   causing us to think that the file does not exist when it in fact does */
-static int
-dblayer_exists_large(const char *path, int *isdirp)
-{
-    struct stat64 sb;
-
-    if (stat64(path, &sb) != 0)
-        return (errno);
-
-    if (isdirp != NULL)
-        *isdirp = S_ISDIR(sb.st_mode);
-
-    return (0);
-}
-
-#else /* DB_USE_64LFS */
-
-int
-dblayer_open_huge_file(const char *path, int oflag, int mode)
-{
-    return open(path, oflag, mode);
-}
-
-#endif /* DB_USE_64LFS */
-
-
-static int
-dblayer_override_libdb_functions(DB_ENV *pEnv __attribute__((unused)), dblayer_private *priv __attribute__((unused)))
-{
-#ifdef DB_USE_64LFS
-    int major = 0;
-    int minor = 0;
-
-    /* Find out whether we are talking to a 2.3 or 2.4+ libdb */
-    db_version(&major, &minor, NULL);
-
-#ifndef irix
-    /* irix doesn't have open64() */
-    db_env_set_func_open((int (*)(const char *, int, ...))dblayer_open_large);
-#endif /* !irix */
-    db_env_set_func_ioinfo(dblayer_ioinfo_large);
-    db_env_set_func_exists(dblayer_exists_large);
-    db_env_set_func_seek((int (*)(int, off_t, int))dblayer_seek43_large);
-
-    slapi_log_err(SLAPI_LOG_TRACE, "dblayer_override_libdb_function", "Enabled 64-bit files\n");
-#endif /* DB_USE_64LFS */
-    return 0;
-}
-
 
 /* This function is called in the initialization code, before the
  * config file is read in, so we can't do much here
